
;CodeVisionAVR C Compiler V2.04.8a Standard
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8535
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 128 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8535
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x025F
	.EQU __DSTACK_SIZE=0x0080
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _Menu=R5
	.DEF _Menu_1=R4
	.DEF __lcd_x=R7
	.DEF __lcd_y=R6
	.DEF __lcd_maxx=R9

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_tbl10_G101:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G101:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x57:
	.DB  0x1,0x0
_0x0:
	.DB  0x20,0x20,0x54,0x65,0x73,0x74,0x20,0x53
	.DB  0x4F,0x4D,0x4F,0x31,0x34,0x2D,0x44,0x20
	.DB  0x0,0x20,0x20,0x5B,0x30,0x33,0x2F,0x30
	.DB  0x33,0x2F,0x32,0x30,0x31,0x31,0x5D,0x20
	.DB  0x20,0x0,0x5B,0x31,0x5D,0x20,0x46,0x69
	.DB  0x63,0x68,0x69,0x65,0x72,0x20,0x3D,0x20
	.DB  0x25,0x2D,0x75,0x0,0x4F,0x4B,0x2B,0x20
	.DB  0x53,0x45,0x54,0x2D,0x20,0x45,0x6E,0x74
	.DB  0x3E,0x3E,0x3E,0x20,0x0,0x5B,0x32,0x5D
	.DB  0x20,0x56,0x6F,0x6C,0x75,0x6D,0x65,0x20
	.DB  0x3D,0x20,0x25,0x2D,0x75,0x0,0x4F,0x4B
	.DB  0x2B,0x20,0x53,0x45,0x54,0x2D,0x20,0x45
	.DB  0x4E,0x54,0x3E,0x50,0x20,0x20,0x0,0x5B
	.DB  0x33,0x5D,0x20,0x53,0x65,0x71,0x28,0x46
	.DB  0x69,0x63,0x68,0x29,0x3D,0x25,0x2D,0x75
	.DB  0x0
_0x2000003:
	.DB  0x1
_0x2000000:
	.DB  0x49,0x3E,0x2B,0x20,0x44,0x3E,0x2D,0x20
	.DB  0x4F,0x3E,0x6D,0x6E,0x20,0x45,0x3E,0x53
	.DB  0x0,0x68,0x3A,0x20,0x25,0x2D,0x75,0x68
	.DB  0x2F,0x25,0x2D,0x75,0x6D,0x6E,0x2F,0x25
	.DB  0x2D,0x75,0x73,0x20,0x0,0x49,0x3E,0x2B
	.DB  0x20,0x44,0x3E,0x2D,0x20,0x4F,0x3E,0x4D
	.DB  0x20,0x45,0x3E,0x53,0x0,0x4A,0x3A,0x20
	.DB  0x25,0x2D,0x75,0x2F,0x25,0x2D,0x75,0x2F
	.DB  0x25,0x2D,0x69,0x0,0x49,0x3E,0x2B,0x20
	.DB  0x44,0x3E,0x2D,0x20,0x4F,0x3E,0x73,0x20
	.DB  0x45,0x3E,0x53,0x0,0x6D,0x6E,0x3A,0x20
	.DB  0x25,0x2D,0x75,0x68,0x2F,0x25,0x2D,0x75
	.DB  0x6D,0x6E,0x2F,0x25,0x2D,0x75,0x73,0x20
	.DB  0x0,0x49,0x3E,0x2B,0x20,0x44,0x3E,0x2D
	.DB  0x20,0x4F,0x3E,0x41,0x20,0x45,0x3E,0x53
	.DB  0x0,0x4D,0x3A,0x20,0x25,0x2D,0x75,0x2F
	.DB  0x25,0x2D,0x75,0x2F,0x25,0x2D,0x69,0x0
	.DB  0x49,0x3E,0x2B,0x20,0x44,0x3E,0x2D,0x20
	.DB  0x4F,0x3E,0x68,0x20,0x45,0x3E,0x53,0x0
	.DB  0x73,0x3A,0x20,0x25,0x2D,0x75,0x68,0x2F
	.DB  0x25,0x2D,0x75,0x6D,0x6E,0x2F,0x25,0x2D
	.DB  0x75,0x73,0x20,0x0,0x49,0x3E,0x2B,0x20
	.DB  0x44,0x3E,0x2D,0x20,0x4F,0x3E,0x4A,0x20
	.DB  0x45,0x3E,0x53,0x0,0x41,0x3A,0x20,0x25
	.DB  0x2D,0x75,0x2F,0x25,0x2D,0x75,0x2F,0x25
	.DB  0x2D,0x69,0x0,0x69,0x6E,0x63,0x2F,0x64
	.DB  0x65,0x63,0x3D,0x2B,0x2F,0x2D,0x20,0x2D
	.DB  0x3E,0x4F,0x6B,0x0,0x25,0x2D,0x75,0x25
	.DB  0x2D,0x75,0x2E,0x25,0x2D,0x75,0x20,0x6D
	.DB  0x6C,0x2F,0x68,0x20,0x2D,0x3E,0x45,0x4E
	.DB  0x54,0x52,0x0,0x31,0x2F,0x33,0x20,0x54
	.DB  0x45,0x52,0x55,0x4D,0x4F,0x20,0x35,0x30
	.DB  0x43,0x43,0x0,0x32,0x2F,0x33,0x20,0x4D
	.DB  0x4F,0x4E,0x2F,0x42,0x44,0x20,0x35,0x30
	.DB  0x43,0x43,0x0,0x33,0x2F,0x33,0x20,0x20
	.DB  0x20,0x20,0x20,0x42,0x44,0x20,0x32,0x30
	.DB  0x43,0x43,0x0,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x3F,0x3F,0x3F,0x3F,0x3F,0x3F
	.DB  0x3F,0x3F,0x0,0x25,0x2D,0x75,0x25,0x2D
	.DB  0x75,0x2E,0x25,0x2D,0x75,0x20,0x6D,0x6D
	.DB  0x2F,0x73,0x20,0x2D,0x3E,0x45,0x4E,0x54
	.DB  0x52,0x0,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x52,0x65,0x6E,0x74,0x72
	.DB  0x65,0x72,0x0,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x53,0x6F,0x72
	.DB  0x74,0x69,0x72,0x0
_0x2060003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x02
	.DW  0x04
	.DW  _0x57*2

	.DW  0x01
	.DW  _Etat_BP_S1000000000
	.DW  _0x2000003*2

	.DW  0x02
	.DW  __base_y_G103
	.DW  _0x2060003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.04.8a Standard
;Automatic Program Generator
; Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : PPE DESIGN
;Version : 1
;Date    : 03/03/2011
;Author  : Philippe Mariano
;Company : Lyce Pierre Emile Martin
;Comments: Test des fonctionnalits de la carte SOMO14-D
;
;
;Chip type               : ATmega8535
;Program type            : Application
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 128
;*****************************************************/
;
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;//-------------------------------------------------------------------------------------------------------
;// Librairies non gnres par Wizard (rajoutes manuellement)
;// ------------------------------------------------------------------------------------------------------
;#include <ssi2.h>       // Contient les fonctions Lire_BP, Affiche_LCD, Regdebit, Select_Seringue
;#include <delay.h>      // Contient la fonction delay_ms
;#include <stdio.h>      // Contient la fonction sprintf
;#include "SOMO14D.h"    // Contient les dclarations et les fonctions pour la gestion du module
;                        // SOMO14D
;// ------------------------------------------------------------------------------------------------------
;// Dclaration pour le module SOMO14-D
;// ------------------------------------------------------------------------------------------------------
;#define NumFichierMax       4           // Nombre de fichiers prsents sur la carte SD
;#define VolumeINIT          3           // Valeur initial de l'incrment de reglage du volume (0  7)
;// ------------------------------------------------------------------------------------------------------
;// Alphanumeric LCD Module functions
;#asm
   .equ __lcd_port=0x15 ;PORTC
; 0000 002A #endasm
;#include <lcd.h>
;// ------------------------------------------------------------------------------------------------------
;// Declare your global variables here
;//-------------------------------------------------------------------------------------------------------
;// type 	            nom              				    Description
;//-------------------------------------------------------------------------------------------------------
;enum EtatMenu{ChoixFichier, ReglageVolume, Sequence}           // Etats du graphe des transitions "Menu"
;			Menu=ChoixFichier, Menu_1= ReglageVolume;
;bit PlayStop = 0;
;// ------------------------------------------------------------------------------------------------------
;// ======================================================================================================
;// Programme principal
;// ======================================================================================================
;void main(void)
; 0000 0039 {

	.CSEG
_main:
; 0000 003A //-------------------------------------------------------------------------------------------------------
; 0000 003B // Declare your local variables here
; 0000 003C //-------------------------------------------------------------------------------------------------------
; 0000 003D // type 	            nom              				    Description
; 0000 003E //-------------------------------------------------------------------------------------------------------
; 0000 003F char display_buffer_ligne0[17]; 						    // Tampon ligne 0 de l'afficheur LCD2x16
; 0000 0040 char display_buffer_ligne1[17]; 						    // Tampon ligne 1 de l'afficheur LCD2x16
; 0000 0041 unsigned int NumFichier=0, NumFichier_1=1;
; 0000 0042 unsigned char Volume=4, Volume_1=1;                         // Incrment compris entre 0 et 7 pour le
; 0000 0043                                                             // rglage du volume
; 0000 0044 unsigned char BP=0;                                         // Bouton-poussoir actionn ou 0 ou 0xFF
; 0000 0045 unsigned char EtatSequence=0, EtatSequence_1=1;
; 0000 0046 //-------------------------------------------------------------------------------------------------------
; 0000 0047 // Input/Output Ports initialization
; 0000 0048 // Port A initialization
; 0000 0049 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 004A // State7=T State6=T State5=P State4=P State3=P State2=P State1=P State0=P
; 0000 004B PORTA=0x3F;
	SBIW R28,37
	LDI  R30,LOW(1)
	ST   Y,R30
	RCALL SUBOPT_0x0
	LDI  R30,LOW(0)
	STD  Y+2,R30
;	display_buffer_ligne0 -> Y+20
;	display_buffer_ligne1 -> Y+3
;	NumFichier -> R16,R17
;	NumFichier_1 -> R18,R19
;	Volume -> R21
;	Volume_1 -> R20
;	BP -> Y+2
;	EtatSequence -> Y+1
;	EtatSequence_1 -> Y+0
	__GETWRN 16,17,0
	__GETWRN 18,19,1
	LDI  R21,4
	LDI  R20,1
	LDI  R30,LOW(63)
	OUT  0x1B,R30
; 0000 004C DDRA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1A,R30
; 0000 004D //-------------------------------------------------------------------------------------------------------
; 0000 004E // Port B initialization
; 0000 004F // Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 0050 // State7=T State6=T State5=T State4=0 State3=0 State2=1 State1=0 State0=0
; 0000 0051 PORTB=0x06; // Impratif pour que le reset et le premier rglage s'effectue correctement !!!!!!!!!!!!!!!
	LDI  R30,LOW(6)
	OUT  0x18,R30
; 0000 0052 DDRB=0x1F;
	LDI  R30,LOW(31)
	OUT  0x17,R30
; 0000 0053 //-------------------------------------------------------------------------------------------------------
; 0000 0054 // Port D initialization
; 0000 0055 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0056 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0057 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 0058 DDRD=0x00;
	OUT  0x11,R30
; 0000 0059 //-------------------------------------------------------------------------------------------------------
; 0000 005A // LCD module initialization
; 0000 005B lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
; 0000 005C //-------------------------------------- Message d'accueil ----------------------------------------------
; 0000 005D lcd_clear();
	RCALL _lcd_clear
; 0000 005E sprintf(display_buffer_ligne0,"  Test SOMO14-D ");
	RCALL SUBOPT_0x1
	__POINTW1FN _0x0,0
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x3
; 0000 005F sprintf(display_buffer_ligne1,"  [03/03/2011]  ");
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,17
	RCALL SUBOPT_0x5
; 0000 0060 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x6
; 0000 0061 delay_ms(4000);
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	RCALL SUBOPT_0x7
; 0000 0062 // ------------------------------------------------------------------------------------------------------
; 0000 0063 // Initialisation du module SOMO14D
; 0000 0064 // ------------------------------------------------------------------------------------------------------
; 0000 0065 InitSOMO14D();                      // Mise  1 de Reset et CLK + squence de reset
	RCALL _InitSOMO14D
; 0000 0066 Somo14DReglageVolume(VolumeINIT);   // Initialis  50%
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _Somo14DReglageVolume
; 0000 0067 //-------------------------------------------------------------------------------------------------------
; 0000 0068 // Boucle principale
; 0000 0069 //-------------------------------------------------------------------------------------------------------
; 0000 006A while (1)
_0x3:
; 0000 006B       {
; 0000 006C       BP = Lire_BP();
	RCALL _Lire_BP
	STD  Y+2,R30
; 0000 006D 
; 0000 006E       switch (Menu)
	MOV  R30,R5
	RCALL SUBOPT_0x8
; 0000 006F       {
; 0000 0070 // Menu 1 : Slection d'un des fichiers de la carte SD
; 0000 0071 //-------------------------------------------------------------------------------------------------------
; 0000 0072         case ChoixFichier: if ((Menu_1 != Menu) || (NumFichier != NumFichier_1))
	SBIW R30,0
	BRNE _0x9
	CP   R5,R4
	BRNE _0xB
	__CPWRR 18,19,16,17
	BREQ _0xA
_0xB:
; 0000 0073                             {
; 0000 0074                                 sprintf(display_buffer_ligne0,"[1] Fichier = %-u",NumFichier);
	RCALL SUBOPT_0x1
	__POINTW1FN _0x0,34
	RCALL SUBOPT_0x9
; 0000 0075                                 sprintf(display_buffer_ligne1,"OK+ SET- Ent>>> ");
	__POINTW1FN _0x0,52
	RCALL SUBOPT_0x5
; 0000 0076                                 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x6
; 0000 0077                                 NumFichier_1 = NumFichier;
	MOVW R18,R16
; 0000 0078                             }
; 0000 0079 
; 0000 007A                             switch (BP)
_0xA:
	RCALL SUBOPT_0xA
; 0000 007B                             {
; 0000 007C                                 case OK: if (NumFichier < NumFichierMax-1) NumFichier = NumFichier + 1;
	BRNE _0x10
	__CPWRN 16,17,3
	BRSH _0x11
	__ADDWRN 16,17,1
; 0000 007D                                             else NumFichier = 0;
	RJMP _0x12
_0x11:
	__GETWRN 16,17,0
; 0000 007E                                 break;
_0x12:
	RJMP _0xF
; 0000 007F                                 case SET: if (NumFichier > 0) NumFichier = NumFichier - 1;
_0x10:
	RCALL SUBOPT_0xB
	BRNE _0x13
	CLR  R0
	CP   R0,R16
	CPC  R0,R17
	BRSH _0x14
	__SUBWRN 16,17,1
; 0000 0080                                             else NumFichier = NumFichierMax-1;
	RJMP _0x15
_0x14:
	__GETWRN 16,17,3
; 0000 0081                                 break;
_0x15:
	RJMP _0xF
; 0000 0082                                 case INC: EtatSequence = 0; Menu = Sequence; break;
_0x13:
	RCALL SUBOPT_0xC
	BRNE _0x16
	RCALL SUBOPT_0x0
	LDI  R30,LOW(2)
	MOV  R5,R30
	RJMP _0xF
; 0000 0083                                 case DEC: Menu =  ReglageVolume;  break;
_0x16:
	RCALL SUBOPT_0xD
	BRNE _0x17
	LDI  R30,LOW(1)
	MOV  R5,R30
	RJMP _0xF
; 0000 0084                                 case ENTR: SendFrameToSomo14D(NumFichier); break;
_0x17:
	RCALL SUBOPT_0xE
	BRNE _0x19
	RCALL SUBOPT_0xF
	RJMP _0xF
; 0000 0085                                 default: Menu = ChoixFichier;
_0x19:
	CLR  R5
; 0000 0086                             }
_0xF:
; 0000 0087 
; 0000 0088                             Menu_1 = ChoixFichier;
	CLR  R4
; 0000 0089 
; 0000 008A         break;
	RJMP _0x8
; 0000 008B // Rglage du volume
; 0000 008C //-------------------------------------------------------------------------------------------------------
; 0000 008D         case ReglageVolume:  if ((Menu_1 != Menu) || (Volume != Volume_1))
_0x9:
	RCALL SUBOPT_0x10
	BRNE _0x1A
	CP   R5,R4
	BRNE _0x1C
	CP   R20,R21
	BREQ _0x1B
_0x1C:
; 0000 008E                             {
; 0000 008F                             sprintf(display_buffer_ligne0,"[2] Volume = %-u", Volume);
	RCALL SUBOPT_0x1
	__POINTW1FN _0x0,69
	RCALL SUBOPT_0x2
	MOV  R30,R21
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
; 0000 0090                             sprintf(display_buffer_ligne1,"OK+ SET- ENT>P  ");
	RCALL SUBOPT_0x4
	__POINTW1FN _0x0,86
	RCALL SUBOPT_0x5
; 0000 0091                             Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x6
; 0000 0092                             Volume_1 = Volume;
	MOV  R20,R21
; 0000 0093                             }
; 0000 0094 
; 0000 0095                             switch (BP)
_0x1B:
	RCALL SUBOPT_0xA
; 0000 0096                             {
; 0000 0097                                 case OK: if (Volume < VolumeMax) Volume = Volume + 1;
	BRNE _0x21
	CPI  R21,7
	BRSH _0x22
	SUBI R21,-LOW(1)
; 0000 0098                                                 else Volume = VolumeMax;
	RJMP _0x23
_0x22:
	LDI  R21,LOW(7)
; 0000 0099                                          Somo14DReglageVolume(Volume);
_0x23:
	RCALL SUBOPT_0x11
; 0000 009A 
; 0000 009B                                 break;
	RJMP _0x20
; 0000 009C                                 case SET: if (Volume > 0) Volume = Volume - 1;
_0x21:
	RCALL SUBOPT_0xB
	BRNE _0x24
	CPI  R21,1
	BRLO _0x25
	RCALL SUBOPT_0x12
; 0000 009D                                                 else Volume = 0;
	RJMP _0x26
_0x25:
	LDI  R21,LOW(0)
; 0000 009E                                           Somo14DReglageVolume(Volume);
_0x26:
	RCALL SUBOPT_0x11
; 0000 009F                                 break;
	RJMP _0x20
; 0000 00A0                                 case ENTR: SendFrameToSomo14D(PlayPause); break;
_0x24:
	RCALL SUBOPT_0xE
	BRNE _0x27
	RCALL SUBOPT_0x13
	RJMP _0x20
; 0000 00A1                                 case INC: Menu = ChoixFichier;  break;
_0x27:
	RCALL SUBOPT_0xC
	BRNE _0x28
	CLR  R5
	RJMP _0x20
; 0000 00A2                                 case DEC: EtatSequence = 0; Menu = Sequence;  break;
_0x28:
	RCALL SUBOPT_0xD
	BRNE _0x2A
	RCALL SUBOPT_0x0
	LDI  R30,LOW(2)
	RJMP _0x53
; 0000 00A3                                 default: Menu =  ReglageVolume;
_0x2A:
	LDI  R30,LOW(1)
_0x53:
	MOV  R5,R30
; 0000 00A4                             }
_0x20:
; 0000 00A5 
; 0000 00A6                             Menu_1 =  ReglageVolume;
	LDI  R30,LOW(1)
	RJMP _0x54
; 0000 00A7         break;
; 0000 00A8 //-------------------------------------------------------------------------------------------------------
; 0000 00A9         case Sequence:  if ((Menu_1 != Menu) || (EtatSequence_1 != EtatSequence))
_0x1A:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x8
	CP   R5,R4
	BRNE _0x2D
	LDD  R30,Y+1
	LD   R26,Y
	CP   R30,R26
	BREQ _0x2C
_0x2D:
; 0000 00AA                             {
; 0000 00AB                                 sprintf(display_buffer_ligne0,"[3] Seq(Fich)=%-u", NumFichier);
	RCALL SUBOPT_0x1
	__POINTW1FN _0x0,103
	RCALL SUBOPT_0x9
; 0000 00AC                                 sprintf(display_buffer_ligne1,"OK+ SET- ENT>P  ");
	__POINTW1FN _0x0,86
	RCALL SUBOPT_0x5
; 0000 00AD                                 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x6
; 0000 00AE                                 EtatSequence_1 = EtatSequence;
	LDD  R30,Y+1
	ST   Y,R30
; 0000 00AF                             }
; 0000 00B0 
; 0000 00B1                           // Dbut squence
; 0000 00B2 
; 0000 00B3                         if (PlayStop == 1)
_0x2C:
	SBRS R2,0
	RJMP _0x2F
; 0000 00B4                          {
; 0000 00B5                           switch(EtatSequence)
	LDD  R30,Y+1
	RCALL SUBOPT_0x8
; 0000 00B6                             {
; 0000 00B7                             case 0 : // Dragster
	SBIW R30,0
	BRNE _0x33
; 0000 00B8                                      if (Busy == 1) break;
	SBIC 0x10,6
	RJMP _0x32
; 0000 00B9                                      else
; 0000 00BA                                         {   delay_ms(50); // Attente aprs libration de Busy
	RCALL SUBOPT_0x14
; 0000 00BB                                             NumFichier = 0;
	__GETWRN 16,17,0
; 0000 00BC                                             SendFrameToSomo14D(NumFichier);
	RCALL SUBOPT_0xF
; 0000 00BD                                             delay_ms(50); // Attente avant relecture de Busy (tBusy min = 20ms)
	RCALL SUBOPT_0x14
; 0000 00BE                                             EtatSequence = 1;
	LDI  R30,LOW(1)
	STD  Y+1,R30
; 0000 00BF                                             break;
	RJMP _0x32
; 0000 00C0                                         }
; 0000 00C1                             case 1 : if (Busy == 1) break; else {  delay_ms(50); NumFichier = 1; SendFrameToSomo14D(NumFichier); delay_ms(50); EtatSequence = 3; break; } // Tir
_0x33:
	RCALL SUBOPT_0x10
	BRNE _0x37
	SBIC 0x10,6
	RJMP _0x32
	RCALL SUBOPT_0x14
	__GETWRN 16,17,1
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x14
	LDI  R30,LOW(3)
	STD  Y+1,R30
	RJMP _0x32
; 0000 00C2                             case 2 : if (Busy == 1) break; else {  delay_ms(50); NumFichier = 2; SendFrameToSomo14D(NumFichier); delay_ms(50); EtatSequence = 0 ; break; } // Salsa
_0x37:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x3B
	SBIC 0x10,6
	RJMP _0x32
	RCALL SUBOPT_0x14
	__GETWRN 16,17,2
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x0
	RJMP _0x32
; 0000 00C3                             case 3 : if (Busy == 1) break; else {  delay_ms(50); NumFichier = 3; SendFrameToSomo14D(NumFichier); delay_ms(50); EtatSequence = 2; break; } // Chien
_0x3B:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x32
	SBIC 0x10,6
	RJMP _0x32
	RCALL SUBOPT_0x14
	__GETWRN 16,17,3
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x14
	LDI  R30,LOW(2)
	STD  Y+1,R30
; 0000 00C4                             }
_0x32:
; 0000 00C5                          }
; 0000 00C6 
; 0000 00C7                         switch (BP)
_0x2F:
	RCALL SUBOPT_0xA
; 0000 00C8                             {
; 0000 00C9                                 case OK: if (Volume < VolumeMax) Volume = Volume + 1;
	BRNE _0x45
	CPI  R21,7
	BRSH _0x46
	SUBI R21,-LOW(1)
; 0000 00CA                                                 else Volume = VolumeMax;
	RJMP _0x47
_0x46:
	LDI  R21,LOW(7)
; 0000 00CB                                          Somo14DReglageVolume(Volume);
_0x47:
	RCALL SUBOPT_0x11
; 0000 00CC 
; 0000 00CD                                 break;
	RJMP _0x44
; 0000 00CE                                 case SET: if (Volume > 0) Volume = Volume - 1;
_0x45:
	RCALL SUBOPT_0xB
	BRNE _0x48
	CPI  R21,1
	BRLO _0x49
	RCALL SUBOPT_0x12
; 0000 00CF                                                 else Volume = 0;
	RJMP _0x4A
_0x49:
	LDI  R21,LOW(0)
; 0000 00D0                                           Somo14DReglageVolume(Volume);
_0x4A:
	RCALL SUBOPT_0x11
; 0000 00D1                                 break;
	RJMP _0x44
; 0000 00D2                                 case ENTR:  if (PlayStop == 1) PlayStop = 0; else PlayStop = 1;
_0x48:
	RCALL SUBOPT_0xE
	BRNE _0x4B
	SBRS R2,0
	RJMP _0x4C
	CLT
	RJMP _0x55
_0x4C:
	SET
_0x55:
	BLD  R2,0
; 0000 00D3                                             SendFrameToSomo14D(PlayPause);
	RCALL SUBOPT_0x13
; 0000 00D4                                 break;
	RJMP _0x44
; 0000 00D5                                 case ECHAP:SendFrameToSomo14D(Stop); break;
_0x4B:
	CPI  R30,LOW(0x3B)
	LDI  R26,HIGH(0x3B)
	CPC  R31,R26
	BRNE _0x4E
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RCALL SUBOPT_0x2
	RCALL _SendFrameToSomo14D
	RJMP _0x44
; 0000 00D6                                 case INC: Menu =  ReglageVolume;  break;
_0x4E:
	RCALL SUBOPT_0xC
	BRNE _0x4F
	LDI  R30,LOW(1)
	RJMP _0x56
; 0000 00D7                                 case DEC: Menu = ChoixFichier;  break;
_0x4F:
	RCALL SUBOPT_0xD
	BRNE _0x51
	CLR  R5
	RJMP _0x44
; 0000 00D8                                 default: Menu = Sequence;
_0x51:
	LDI  R30,LOW(2)
_0x56:
	MOV  R5,R30
; 0000 00D9                             }
_0x44:
; 0000 00DA 
; 0000 00DB                             Menu_1 = Sequence;
	LDI  R30,LOW(2)
_0x54:
	MOV  R4,R30
; 0000 00DC         break;
; 0000 00DD       } // fin du while
_0x8:
; 0000 00DE //-------------------------------------------------------------------------------------------------------
; 0000 00DF     } // fin du while
	RJMP _0x3
; 0000 00E0 //-------------------------------------------------------------------------------------------------------
; 0000 00E1 } // fin du main
_0x52:
	RJMP _0x52
;//-------------------------------------------------------------------------------------------------------
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_Lire_BP:

	.DSEG

	.CSEG
	RCALL __SAVELOCR2
	IN   R30,0x19
	ANDI R30,LOW(0x3F)
	MOV  R16,R30
	LDS  R30,_Etat_BP_S1000000000
	RCALL SUBOPT_0x8
	SBIW R30,0
	BRNE _0x2000007
	CPI  R16,63
	BRNE _0x2000008
	MOV  R17,R16
	RCALL SUBOPT_0x14
	IN   R30,0x19
	ANDI R30,LOW(0x3F)
	MOV  R16,R30
	CP   R16,R17
	BRNE _0x2000009
	LDI  R30,LOW(1)
	STS  _Etat_BP_S1000000000,R30
	LDI  R30,LOW(255)
	RJMP _0x2100005
_0x2000009:
	LDI  R30,LOW(0)
	RJMP _0x2100005
_0x2000008:
	LDI  R30,LOW(0)
	RJMP _0x2100005
_0x2000007:
	RCALL SUBOPT_0x10
	BRNE _0x2000006
	CPI  R16,63
	BREQ _0x200000D
	MOV  R17,R16
	RCALL SUBOPT_0x14
	ANDI R16,LOW(63)
	CP   R16,R17
	BRNE _0x200000E
	LDI  R30,LOW(0)
	STS  _Etat_BP_S1000000000,R30
	MOV  R30,R16
	RJMP _0x2100005
_0x200000E:
	LDI  R30,LOW(255)
	RJMP _0x2100005
_0x200000D:
	LDI  R30,LOW(255)
_0x2000006:
_0x2100005:
	RCALL __LOADLOCR2P
	RET
_Affiche_LCD:
	RCALL _lcd_clear
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RCALL SUBOPT_0x2
	RCALL _lcd_puts
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_gotoxy
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x2
	RCALL _lcd_puts
	ADIW R28,4
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G101:
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x15
	ADIW R26,2
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x2020010
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x16
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2020012
	__CPWRN 16,17,2
	BRLO _0x2020013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2020012:
	RCALL SUBOPT_0x15
	ADIW R26,2
	RCALL SUBOPT_0x17
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	RCALL SUBOPT_0x15
	RCALL __GETW1P
	TST  R31
	BRMI _0x2020014
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x17
_0x2020014:
_0x2020013:
	RJMP _0x2020015
_0x2020010:
	RCALL SUBOPT_0x15
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2020015:
	RCALL __LOADLOCR2
	ADIW R28,5
	RET
__print_G101:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2020016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x2020018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x202001C
	CPI  R18,37
	BRNE _0x202001D
	LDI  R17,LOW(1)
	RJMP _0x202001E
_0x202001D:
	RCALL SUBOPT_0x18
_0x202001E:
	RJMP _0x202001B
_0x202001C:
	CPI  R30,LOW(0x1)
	BRNE _0x202001F
	CPI  R18,37
	BRNE _0x2020020
	RCALL SUBOPT_0x18
	RJMP _0x20200C9
_0x2020020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2020021
	LDI  R16,LOW(1)
	RJMP _0x202001B
_0x2020021:
	CPI  R18,43
	BRNE _0x2020022
	LDI  R20,LOW(43)
	RJMP _0x202001B
_0x2020022:
	CPI  R18,32
	BRNE _0x2020023
	LDI  R20,LOW(32)
	RJMP _0x202001B
_0x2020023:
	RJMP _0x2020024
_0x202001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2020025
_0x2020024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2020026
	ORI  R16,LOW(128)
	RJMP _0x202001B
_0x2020026:
	RJMP _0x2020027
_0x2020025:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x202001B
_0x2020027:
	CPI  R18,48
	BRLO _0x202002A
	CPI  R18,58
	BRLO _0x202002B
_0x202002A:
	RJMP _0x2020029
_0x202002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x202001B
_0x2020029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x202002F
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x19
	LDD  R26,Z+4
	ST   -Y,R26
	RCALL SUBOPT_0x1B
	RJMP _0x2020030
_0x202002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2020032
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x1E
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x2020033
_0x2020032:
	CPI  R30,LOW(0x70)
	BRNE _0x2020035
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x1E
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2020033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2020036
_0x2020035:
	CPI  R30,LOW(0x64)
	BREQ _0x2020039
	CPI  R30,LOW(0x69)
	BRNE _0x202003A
_0x2020039:
	ORI  R16,LOW(4)
	RJMP _0x202003B
_0x202003A:
	CPI  R30,LOW(0x75)
	BRNE _0x202003C
_0x202003B:
	LDI  R30,LOW(_tbl10_G101*2)
	LDI  R31,HIGH(_tbl10_G101*2)
	RCALL SUBOPT_0x1F
	LDI  R17,LOW(5)
	RJMP _0x202003D
_0x202003C:
	CPI  R30,LOW(0x58)
	BRNE _0x202003F
	ORI  R16,LOW(8)
	RJMP _0x2020040
_0x202003F:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x2020071
_0x2020040:
	LDI  R30,LOW(_tbl16_G101*2)
	LDI  R31,HIGH(_tbl16_G101*2)
	RCALL SUBOPT_0x1F
	LDI  R17,LOW(4)
_0x202003D:
	SBRS R16,2
	RJMP _0x2020042
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x20
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2020043
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	RCALL SUBOPT_0x20
	LDI  R20,LOW(45)
_0x2020043:
	CPI  R20,0
	BREQ _0x2020044
	SUBI R17,-LOW(1)
	RJMP _0x2020045
_0x2020044:
	ANDI R16,LOW(251)
_0x2020045:
	RJMP _0x2020046
_0x2020042:
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x20
_0x2020046:
_0x2020036:
	SBRC R16,0
	RJMP _0x2020047
_0x2020048:
	CP   R17,R21
	BRSH _0x202004A
	SBRS R16,7
	RJMP _0x202004B
	SBRS R16,2
	RJMP _0x202004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x202004D
_0x202004C:
	LDI  R18,LOW(48)
_0x202004D:
	RJMP _0x202004E
_0x202004B:
	LDI  R18,LOW(32)
_0x202004E:
	RCALL SUBOPT_0x18
	SUBI R21,LOW(1)
	RJMP _0x2020048
_0x202004A:
_0x2020047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x202004F
_0x2020050:
	CPI  R19,0
	BREQ _0x2020052
	SBRS R16,3
	RJMP _0x2020053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	RCALL SUBOPT_0x1F
	RJMP _0x2020054
_0x2020053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2020054:
	RCALL SUBOPT_0x18
	CPI  R21,0
	BREQ _0x2020055
	SUBI R21,LOW(1)
_0x2020055:
	SUBI R19,LOW(1)
	RJMP _0x2020050
_0x2020052:
	RJMP _0x2020056
_0x202004F:
_0x2020058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	RCALL SUBOPT_0x1F
_0x202005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x202005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	RCALL SUBOPT_0x20
	RJMP _0x202005A
_0x202005C:
	CPI  R18,58
	BRLO _0x202005D
	SBRS R16,3
	RJMP _0x202005E
	SUBI R18,-LOW(7)
	RJMP _0x202005F
_0x202005E:
	SUBI R18,-LOW(39)
_0x202005F:
_0x202005D:
	SBRC R16,4
	RJMP _0x2020061
	CPI  R18,49
	BRSH _0x2020063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2020062
_0x2020063:
	RJMP _0x20200CA
_0x2020062:
	CP   R21,R19
	BRLO _0x2020067
	SBRS R16,0
	RJMP _0x2020068
_0x2020067:
	RJMP _0x2020066
_0x2020068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2020069
	LDI  R18,LOW(48)
_0x20200CA:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x202006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	RCALL SUBOPT_0x1B
	CPI  R21,0
	BREQ _0x202006B
	SUBI R21,LOW(1)
_0x202006B:
_0x202006A:
_0x2020069:
_0x2020061:
	RCALL SUBOPT_0x18
	CPI  R21,0
	BREQ _0x202006C
	SUBI R21,LOW(1)
_0x202006C:
_0x2020066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2020059
	RJMP _0x2020058
_0x2020059:
_0x2020056:
	SBRS R16,0
	RJMP _0x202006D
_0x202006E:
	CPI  R21,0
	BREQ _0x2020070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL SUBOPT_0x1B
	RJMP _0x202006E
_0x2020070:
_0x202006D:
_0x2020071:
_0x2020030:
_0x20200C9:
	LDI  R17,LOW(0)
_0x202001B:
	RJMP _0x2020016
_0x2020018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	RCALL __GETW1P
	RCALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	RCALL __SAVELOCR4
	RCALL SUBOPT_0x21
	SBIW R30,0
	BRNE _0x2020072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2100004
_0x2020072:
	MOVW R26,R28
	ADIW R26,6
	RCALL __ADDW2R15
	MOVW R16,R26
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x1F
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __ADDW2R15
	RCALL __GETW1P
	RCALL SUBOPT_0x2
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G101)
	LDI  R31,HIGH(_put_buff_G101)
	RCALL SUBOPT_0x2
	MOVW R30,R28
	ADIW R30,10
	RCALL SUBOPT_0x2
	RCALL __print_G101
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x2100004:
	RCALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_InitSOMO14D:
	SBI  0x18,2
	SBI  0x18,1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x7
	RCALL _Somo14DReset
	RET
_Somo14DReset:
	CBI  0x18,2
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x7
	SBI  0x18,2
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0x7
	RET
_Somo14DStart:
	CBI  0x18,1
	RJMP _0x2100003
_Somo14DStop:
	SBI  0x18,1
_0x2100003:
	__DELAY_USW 5000
	RET
_Somo14DTransfertInt:
	RCALL __SAVELOCR4
	LDI  R19,LOW(0)
_0x2040013:
	CPI  R19,16
	BRSH _0x2040014
	CBI  0x18,1
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ANDI R30,LOW(0x8000)
	ANDI R31,HIGH(0x8000)
	MOVW R16,R30
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x2040017
	CBI  0x18,0
	RJMP _0x204001A
_0x2040017:
	SBI  0x18,0
_0x204001A:
	RCALL SUBOPT_0x22
	SBI  0x18,1
	RCALL SUBOPT_0x22
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	LSL  R30
	ROL  R31
	STD  Y+4,R30
	STD  Y+4+1,R31
	SUBI R19,-1
	RJMP _0x2040013
_0x2040014:
	RCALL __LOADLOCR4
	ADIW R28,6
	RET
_Somo14DReglageVolume:
	RCALL _Somo14DStart
	LD   R30,Y
	RCALL SUBOPT_0x8
	SUBI R30,LOW(-65520)
	SBCI R31,HIGH(-65520)
	RCALL SUBOPT_0x2
	RCALL _Somo14DTransfertInt
	RCALL _Somo14DStop
	RJMP _0x2100001
_SendFrameToSomo14D:
	RCALL _Somo14DStart
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x2
	RCALL _Somo14DTransfertInt
	RCALL _Somo14DStop
	RJMP _0x2100002
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG

	.CSEG
__lcd_delay_G103:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	RCALL __lcd_delay_G103
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G103
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G103
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G103
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G103:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G103
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G103
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G103
    ld    r26,y
    swap  r26
	RCALL __lcd_write_nibble_G103
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x2100001
__lcd_read_nibble_G103:
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G103
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G103
    andi  r30,0xf0
	RET
_lcd_read_byte0_G103:
	RCALL __lcd_delay_G103
	RCALL __lcd_read_nibble_G103
    mov   r26,r30
	RCALL __lcd_read_nibble_G103
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	RCALL SUBOPT_0x8
	SUBI R30,LOW(-__base_y_G103)
	SBCI R31,HIGH(-__base_y_G103)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x23
	LDD  R7,Y+1
	LDD  R6,Y+0
_0x2100002:
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x23
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x23
	RCALL __lcd_ready
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x23
	LDI  R30,LOW(0)
	MOV  R6,R30
	MOV  R7,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	CP   R7,R9
	BRLO _0x2060004
	__lcd_putchar1:
	INC  R6
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R6
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x2060004:
	INC  R7
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	RJMP _0x2100001
_lcd_puts:
	ST   -Y,R17
_0x2060005:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2060007
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2060005
_0x2060007:
	LDD  R17,Y+0
	ADIW R28,3
	RET
__long_delay_G103:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G103:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G103
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x2100001
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R9,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G103,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G103,3
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x24
	RCALL __long_delay_G103
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G103
	RCALL __long_delay_G103
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x23
	RCALL __long_delay_G103
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x23
	RCALL __long_delay_G103
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x23
	RCALL __long_delay_G103
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G103
	CPI  R30,LOW(0x5)
	BREQ _0x206000B
	LDI  R30,LOW(0)
	RJMP _0x2100001
_0x206000B:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x23
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x2100001:
	ADIW R28,1
	RET

	.CSEG

	.CSEG

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG

	.DSEG
___rtc_status:
	.BYTE 0x1
_Etat_BP_S1000000000:
	.BYTE 0x1
__base_y_G103:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(0)
	STD  Y+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x1:
	MOVW R30,R28
	ADIW R30,20
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 50 TIMES, CODE SIZE REDUCTION:47 WORDS
SUBOPT_0x2:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3:
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4:
	MOVW R30,R28
	ADIW R30,3
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	RCALL SUBOPT_0x2
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x6:
	MOVW R30,R28
	ADIW R30,5
	RCALL SUBOPT_0x2
	RJMP _Affiche_LCD

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x7:
	RCALL SUBOPT_0x2
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x8:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x9:
	RCALL SUBOPT_0x2
	MOVW R30,R16
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xA:
	LDD  R30,Y+2
	RCALL SUBOPT_0x8
	CPI  R30,LOW(0x37)
	LDI  R26,HIGH(0x37)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xB:
	CPI  R30,LOW(0x3D)
	LDI  R26,HIGH(0x3D)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xC:
	CPI  R30,LOW(0x1F)
	LDI  R26,HIGH(0x1F)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xD:
	CPI  R30,LOW(0x2F)
	LDI  R26,HIGH(0x2F)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xE:
	CPI  R30,LOW(0x3E)
	LDI  R26,HIGH(0x3E)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xF:
	ST   -Y,R17
	ST   -Y,R16
	RJMP _SendFrameToSomo14D

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x10:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	ST   -Y,R21
	RJMP _Somo14DReglageVolume

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	MOV  R30,R21
	RCALL SUBOPT_0x8
	SBIW R30,1
	MOV  R21,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x13:
	LDI  R30,LOW(65534)
	LDI  R31,HIGH(65534)
	RCALL SUBOPT_0x2
	RJMP _SendFrameToSomo14D

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x14:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RJMP SUBOPT_0x7

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x15:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x16:
	ADIW R26,4
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x17:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x18:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	RCALL SUBOPT_0x2
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x19:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1A:
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x1B:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	RCALL SUBOPT_0x2
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	RCALL SUBOPT_0x19
	RJMP SUBOPT_0x1A

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1D:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	RJMP SUBOPT_0x16

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1E:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1F:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x20:
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x21:
	MOVW R26,R28
	ADIW R26,12
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x22:
	__DELAY_USW 300
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x23:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x24:
	RCALL __long_delay_G103
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G103


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
