/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.8a Standard
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : PPE DESIGN 
Version : 1
Date    : 03/03/2011
Author  : Philippe Mariano
Company : Lyce Pierre Emile Martin
Comments: Test des fonctionnalits de la carte SOMO14-D 


Chip type               : ATmega8535
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 128
*****************************************************/

#include <mega8535.h>
//-------------------------------------------------------------------------------------------------------
// Librairies non gnres par Wizard (rajoutes manuellement)
// ------------------------------------------------------------------------------------------------------
#include <ssi2.h>       // Contient les fonctions Lire_BP, Affiche_LCD, Regdebit, Select_Seringue
#include <delay.h>      // Contient la fonction delay_ms
#include <stdio.h>      // Contient la fonction sprintf
#include "SOMO14D.h"    // Contient les dclarations et les fonctions pour la gestion du module
                        // SOMO14D
// ------------------------------------------------------------------------------------------------------
// Dclaration pour le module SOMO14-D
// ------------------------------------------------------------------------------------------------------
#define NumFichierMax       4           // Nombre de fichiers prsents sur la carte SD
#define VolumeINIT          3           // Valeur initial de l'incrment de reglage du volume (0  7)
// ------------------------------------------------------------------------------------------------------
// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15 ;PORTC
#endasm
#include <lcd.h>
// ------------------------------------------------------------------------------------------------------
// Declare your global variables here
//-------------------------------------------------------------------------------------------------------
// type 	            nom              				    Description
//-------------------------------------------------------------------------------------------------------
enum EtatMenu{ChoixFichier, ReglageVolume, Sequence}           // Etats du graphe des transitions "Menu"
			Menu=ChoixFichier, Menu_1= ReglageVolume; 
bit PlayStop = 0;                                           
// ------------------------------------------------------------------------------------------------------
// ======================================================================================================
// Programme principal
// ======================================================================================================
void main(void)
{
//-------------------------------------------------------------------------------------------------------
// Declare your local variables here
//-------------------------------------------------------------------------------------------------------
// type 	            nom              				    Description
//-------------------------------------------------------------------------------------------------------
char display_buffer_ligne0[17]; 						    // Tampon ligne 0 de l'afficheur LCD2x16
char display_buffer_ligne1[17]; 						    // Tampon ligne 1 de l'afficheur LCD2x16
unsigned int NumFichier=0, NumFichier_1=1;
unsigned char Volume=4, Volume_1=1;                         // Incrment compris entre 0 et 7 pour le
                                                            // rglage du volume 
unsigned char BP=0;                                         // Bouton-poussoir actionn ou 0 ou 0xFF
unsigned char EtatSequence=0, EtatSequence_1=1;
//-------------------------------------------------------------------------------------------------------
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=P State4=P State3=P State2=P State1=P State0=P
PORTA=0x3F;
DDRA=0x00;
//-------------------------------------------------------------------------------------------------------
// Port B initialization
// Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=T State6=T State5=T State4=0 State3=0 State2=1 State1=0 State0=0 
PORTB=0x06; // Impratif pour que le reset et le premier rglage s'effectue correctement !!!!!!!!!!!!!!!
DDRB=0x1F;
//-------------------------------------------------------------------------------------------------------
// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;
//-------------------------------------------------------------------------------------------------------
// LCD module initialization
lcd_init(16);
//-------------------------------------- Message d'accueil ----------------------------------------------
lcd_clear();
sprintf(display_buffer_ligne0,"  Test SOMO14-D ");
sprintf(display_buffer_ligne1,"  [03/03/2011]  ");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
delay_ms(4000);
// ------------------------------------------------------------------------------------------------------
// Initialisation du module SOMO14D
// ------------------------------------------------------------------------------------------------------
InitSOMO14D();                      // Mise  1 de Reset et CLK + squence de reset
Somo14DReglageVolume(VolumeINIT);   // Initialis  50%
//-------------------------------------------------------------------------------------------------------
// Boucle principale
//-------------------------------------------------------------------------------------------------------
while (1)
      { 
      BP = Lire_BP();

      switch (Menu)
      {
// Menu 1 : Slection d'un des fichiers de la carte SD      
//-------------------------------------------------------------------------------------------------------  
        case ChoixFichier: if ((Menu_1 != Menu) || (NumFichier != NumFichier_1))
                            {
                                sprintf(display_buffer_ligne0,"[1] Fichier = %-u",NumFichier);
                                sprintf(display_buffer_ligne1,"OK+ SET- Ent>>> ");
                                Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                                NumFichier_1 = NumFichier;
                            } 
                            
                            switch (BP)
                            {
                                case OK: if (NumFichier < NumFichierMax-1) NumFichier = NumFichier + 1;
                                            else NumFichier = 0;  
                                break;
                                case SET: if (NumFichier > 0) NumFichier = NumFichier - 1; 
                                            else NumFichier = NumFichierMax-1; 
                                break;
                                case INC: EtatSequence = 0; Menu = Sequence; break;
                                case DEC: Menu =  ReglageVolume;  break;
                                case ENTR: SendFrameToSomo14D(NumFichier); break;
                                default: Menu = ChoixFichier;  
                            }
       		          
                            Menu_1 = ChoixFichier;
        
        break;
// Rglage du volume
//-------------------------------------------------------------------------------------------------------       
        case ReglageVolume:  if ((Menu_1 != Menu) || (Volume != Volume_1)) 
                            {
                            sprintf(display_buffer_ligne0,"[2] Volume = %-u", Volume);
                            sprintf(display_buffer_ligne1,"OK+ SET- ENT>P  ");
                            Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                            Volume_1 = Volume;
                            } 
                            
                            switch (BP)
                            {
                                case OK: if (Volume < VolumeMax) Volume = Volume + 1; 
                                                else Volume = VolumeMax;
                                         Somo14DReglageVolume(Volume);  
                                         
                                break;
                                case SET: if (Volume > 0) Volume = Volume - 1; 
                                                else Volume = 0;  
                                          Somo14DReglageVolume(Volume);
                                break;
                                case ENTR: SendFrameToSomo14D(PlayPause); break;
                                case INC: Menu = ChoixFichier;  break;
                                case DEC: EtatSequence = 0; Menu = Sequence;  break;
                                default: Menu =  ReglageVolume; 
                            }
       		          
                            Menu_1 =  ReglageVolume;
        break;
//-------------------------------------------------------------------------------------------------------       
        case Sequence:  if ((Menu_1 != Menu) || (EtatSequence_1 != EtatSequence))
                            {
                                sprintf(display_buffer_ligne0,"[3] Seq(Fich)=%-u", NumFichier);
                                sprintf(display_buffer_ligne1,"OK+ SET- ENT>P  ");
                                Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                                EtatSequence_1 = EtatSequence;
                            }  
                            
                          // Dbut squence 
                          
                        if (PlayStop == 1) 
                         {   
                          switch(EtatSequence)
                            {
                            case 0 : // Dragster
                                     if (Busy == 1) break; 
                                     else 
                                        {   delay_ms(50); // Attente aprs libration de Busy
                                            NumFichier = 0; 
                                            SendFrameToSomo14D(NumFichier); 
                                            delay_ms(50); // Attente avant relecture de Busy (tBusy min = 20ms) 
                                            EtatSequence = 1; 
                                            break; 
                                        }
                            case 1 : if (Busy == 1) break; else {  delay_ms(50); NumFichier = 1; SendFrameToSomo14D(NumFichier); delay_ms(50); EtatSequence = 3; break; } // Tir
                            case 2 : if (Busy == 1) break; else {  delay_ms(50); NumFichier = 2; SendFrameToSomo14D(NumFichier); delay_ms(50); EtatSequence = 0 ; break; } // Salsa
                            case 3 : if (Busy == 1) break; else {  delay_ms(50); NumFichier = 3; SendFrameToSomo14D(NumFichier); delay_ms(50); EtatSequence = 2; break; } // Chien
                            }
                         } 
                           
                        switch (BP)
                            {
                                case OK: if (Volume < VolumeMax) Volume = Volume + 1; 
                                                else Volume = VolumeMax;
                                         Somo14DReglageVolume(Volume);  
                                         
                                break;
                                case SET: if (Volume > 0) Volume = Volume - 1; 
                                                else Volume = 0;  
                                          Somo14DReglageVolume(Volume);
                                break;
                                case ENTR:  if (PlayStop == 1) PlayStop = 0; else PlayStop = 1;
                                            SendFrameToSomo14D(PlayPause); 
                                break;
                                case ECHAP:SendFrameToSomo14D(Stop); break;
                                case INC: Menu =  ReglageVolume;  break;
                                case DEC: Menu = ChoixFichier;  break;
                                default: Menu = Sequence; 
                            }
       		          
                            Menu_1 = Sequence;
        break;
      } // fin du while
//-------------------------------------------------------------------------------------------------------  
    } // fin du while
//-------------------------------------------------------------------------------------------------------
} // fin du main
//-------------------------------------------------------------------------------------------------------